//
//  ASP51NV2.h
//  P51NV2
//
//  Created by Robin on 2018. 10. 29..
//  Copyright © 2018년 Robin. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef NS_ENUM(NSUInteger, ASP51NV2NetworkState) {
    ASP51NV2NetworkStateUnknown = 0,
    ASP51NV2NetworkStateConnected,
    ASP51NV2NetworkStateDisconnected,
    ASP51NV2NetworkStateError,
};

typedef NS_ENUM(NSUInteger, ASP51NV2TargetMemoryType) {
    ASP51NV2TargetMemoryTypeKill,
    ASP51NV2TargetMemoryTypeAccess,
    ASP51NV2TargetMemoryTypeEPC,
    ASP51NV2TargetMemoryTypeTID,
    ASP51NV2TargetMemoryTypeUser,
};

typedef NS_ENUM(NSUInteger, ASP51NV2LockActionType) {
    ASP51NV2LockActionTypeUnlock,
    ASP51NV2LockActionTypePermaUnlock,
    ASP51NV2LockActionTypeLock,
    ASP51NV2LockActionTypePermaLock,
};

typedef NS_ENUM(uint32_t, ASP51NV2RegionType) {
    ASP51NV2RegionTypeFccPart_15_247 = 0x0,
    ASP51NV2RegionTypeHongKong_920_925_MHZ = 0x3,
    ASP51NV2RegionTypeTaiWan_922_928_MHZ = 0x4,
    ASP51NV2RegionTypeEtsiEN_302_208_V1_4_1 = 0x7,
    ASP51NV2RegionTypeKorea_917_921_MHZ = 0x8,
    ASP51NV2RegionTypeMalaysia_919_923_MHZ = 0x9,
    ASP51NV2RegionTypeChina_920_925_MHZ = 0xA,
    ASP51NV2RegionTypeSouthAfrica_915_919_MHZ = 0xC,
    ASP51NV2RegionTypeBrazil_902_907_AND_915_928_MHZ = 0xD,
    ASP51NV2RegionTypeThailand_920_925_MHZ = 0xE,
    ASP51NV2RegionTypeSingapore_920_925_MHZ = 0xF,
    ASP51NV2RegionTypeAustralia_920_926_MHZ = 0x10,
    ASP51NV2RegionTypeIndia_865_867_MHZ = 0x11,
    ASP51NV2RegionTypeUruguay_916_928_MHZ = 0x12,
    ASP51NV2RegionTypeVietnam_920_925_MHZ = 0x13,
    ASP51NV2RegionTypeIsrael_915_917_MHZ = 0x14,
    ASP51NV2RegionTypePhilippines_918_920_MHZ = 0x15,
    ASP51NV2RegionTypeIndonesia_923_925_MHZ = 0x17,
    ASP51NV2RegionTypeNewzealand_921P5_928_MHZ = 0x18,
    ASP51NV2RegionTypeJapan_916_921_MHZ_NO_LBT = 0x19,
    ASP51NV2RegionTypePeru_916_928_MHZ = 0x1A,
    ASP51NV2RegionTypeRussia_916_921_MHZ = 0x1B,
    ASP51NV2RegionTypeCustom = 0x100,
};

typedef NS_ENUM(uint32_t, ASP51NV2RFModeType) {
    ASP51NV2RFModeType_E0 = 0x0,    //Auto (Defaults to mode 1)
    ASP51NV2RFModeType_E1 = 0x1,    //Dense Reader Mode profile for FCC operation
    ASP51NV2RFModeType_E2 = 0x2,    //Dense Reader Mode profile for ETSI operation
    ASP51NV2RFModeType_E3 = 0x3,    //Very fast mode with reduced sensitivity and noise immunity
    ASP51NV2RFModeType_E4 = 0x4,    //Very sensitive mode with reduced speed and reduced noise immunity
};

typedef NS_ENUM(uint32_t, ASP51NV2SessionType) {
    ASP51NV2SessionType_S0 = 0x0,
    ASP51NV2SessionType_S1 = 0x1,
    ASP51NV2SessionType_S2 = 0x2,
    ASP51NV2SessionType_S3 = 0x3,
};

typedef NS_ENUM(uint32_t, ASP51NV2SearchModeType) {
    ASP51NV2SearchModeTypeAutoSearch = 0x0,
    ASP51NV2SearchModeTypeDualTarget = 0x1,
    ASP51NV2SearchModeTypeSingleTarget_A_TO_B = 0x2,
    ASP51NV2SearchModeTypeSingleTarget_B_TO_A = 0x3,
};

typedef NS_ENUM(uint32_t, ASP51NV2SelectTargetType) {
    ASP51NV2SelectTargetType_S0 = 0x0,
    ASP51NV2SelectTargetType_S1 = 0x1,
    ASP51NV2SelectTargetType_S2 = 0x2,
    ASP51NV2SelectTargetType_S3 = 0x3,
    ASP51NV2SelectTargetType_SL_FLAG  = 0x4,
    ASP51NV2SelectTargetType_RFU_1    = 0x5,
    ASP51NV2SelectTargetType_RFU_2    = 0x6,
    ASP51NV2SelectTargetType_RFU_3    = 0x7,
};

/*
 ASLINVA:assert SL or inventoried → A
 DSLINVB:deassert SL or inventoried → B
 NOTHING:do nothing
 NSLINVS:negate SL or (A → B, B → A)
 */
typedef NS_ENUM(uint32_t, ASP51NV2SelectActionType) {
    ASP51NV2SelectActionTypeASLINVA_DSLINVB = 0x0,
    ASP51NV2SelectActionTypeASLINVA_NOTHING = 0x1,
    ASP51NV2SelectActionTypeNOTHING_DSLINVB = 0x2,
    ASP51NV2SelectActionTypeNSLINVS_NOTHING = 0x3,
    ASP51NV2SelectActionTypeDSLINVB_ASLINVA = 0x4,
    ASP51NV2SelectActionTypeDSLINVB_NOTHING = 0x5,
    ASP51NV2SelectActionTypeNOTHING_ASLINVA = 0x6,
    ASP51NV2SelectActionTypeNOTHING_NSLINVS = 0x7,
};

typedef NS_ENUM(uint32_t, ASP51NV2MemoryBankType) {
    ASP51NV2MemoryBankTypeReserved = 0x0,
    ASP51NV2MemoryBankTypeEPC = 0x1,
    ASP51NV2MemoryBankTypeTID = 0x2,
    ASP51NV2MemoryBankTypeUser = 0x3,
};

typedef NS_ENUM(uint32_t, ASP51NV2DeviceSettingType) {
    ASP51NV2DeviceSettingTypeBootstrapVersion_R = 0x1,
    ASP51NV2DeviceSettingTypeBootstrapCRC_R = 0x2,
    ASP51NV2DeviceSettingTypeApplicationVersion_R = 0x3,
    ASP51NV2DeviceSettingTypeApplicationCRC_R = 0x4,
    ASP51NV2DeviceSettingTypeSecondaryImageVersion_R = 0x5,
    ASP51NV2DeviceSettingTypeSecondaryImageCRC_R = 0x6,
    ASP51NV2DeviceSettingTypeSecondaryImageType_R = 0x7,
    ASP51NV2DeviceSettingTypeApplicationRevisionID_R = 0x8,
    ASP51NV2DeviceSettingTypeApplicationBuildID_R = 0x9,
    ASP51NV2DeviceSettingTypeProductID_R = 0xA,
    ASP51NV2DeviceSettingTypeSerialNumber_R = 0xB,
    ASP51NV2DeviceSettingTypeTransceiverID_R = 0xC,
    ASP51NV2DeviceSettingTypeMicroprocessorID_R = 0xD,
    ASP51NV2DeviceSettingTypeCustomerVersion_R = 0xE,
    ASP51NV2DeviceSettingTypeCustomerID_R = 0xF,
    ASP51NV2DeviceSettingTypeCustomerProductID_R = 0x10,
    ASP51NV2DeviceSettingTypeCalibrationInfo_R = 0x11,
    ASP51NV2DeviceSettingTypeTestInfo_R = 0x12,
    ASP51NV2DeviceSettingTypeProductSKU_R = 0x13,
    ASP51NV2DeviceSettingTypeLotDateCode_R = 0x14,
    ASP51NV2DeviceSettingTypeProductKey_R = 0x15,
    ASP51NV2DeviceSettingTypeSecondaryImageLocation_R = 0x16,
    ASP51NV2DeviceSettingTypeSecondaryImageSize_R = 0x17,
    ASP51NV2DeviceSettingTypeUniqueID_R = 0x18,
    ASP51NV2DeviceSettingTypeHardwareRevision_R = 0x19,
    ASP51NV2DeviceSettingTypeSystemTimestampMS_R = 0x1A,
    ASP51NV2DeviceSettingTypeActiveActions_R = 0x1B,
    ASP51NV2DeviceSettingTypeRegionID_RW = 0x20,
    ASP51NV2DeviceSettingTypeRegionChannelTable_RW = 0x21,
    ASP51NV2DeviceSettingTypeRegionChannelTableSize_RW = 0x22,
    ASP51NV2DeviceSettingTypeRegionOnTimeNominal_RW = 0x23,
    ASP51NV2DeviceSettingTypeRegionOnTimeAccess_RW = 0x24,
    ASP51NV2DeviceSettingTypeRegionOffTime_RW = 0x25,
    ASP51NV2DeviceSettingTypeRegionOffTimeSameChannel_RW = 0x26,
    ASP51NV2DeviceSettingTypeRegionStartFrequencyKHZ_RW = 0x27,
    ASP51NV2DeviceSettingTypeRegionChannelSpacingKHZ_RW = 0x28,
    ASP51NV2DeviceSettingTypeRegionRandomHOP_RW = 0x29,
    ASP51NV2DeviceSettingTypeRegionIndy_PLL_R_Divider_RW = 0x2A,
    ASP51NV2DeviceSettingTypeRegionRF_Filter_RW = 0x2B,
    ASP51NV2DeviceSettingTypeAntennaTX_Power_RW = 0x31,
    ASP51NV2DeviceSettingTypeANTennaSequence_RW = 0x32,
    ASP51NV2DeviceSettingTypeInventoryTagPopulation_RW = 0x40,
    ASP51NV2DeviceSettingTypeInventorySelectFlag_RW = 0x41,
    ASP51NV2DeviceSettingTypeInventorySession_RW = 0x42,
    ASP51NV2DeviceSettingTypeInventorySearchMode_RW = 0x43,
    ASP51NV2DeviceSettingTypeFastIDEnable_RW = 0x45,
    ASP51NV2DeviceSettingTypeTagFocusEnable_RW = 0x46,
    ASP51NV2DeviceSettingTypeTagOperationEnable_RW = 0x47,
    ASP51NV2DeviceSettingTypeTagOperationRetries_RW = 0x48,
    ASP51NV2DeviceSettingTypeSelectEnable_RW = 0x50,
    ASP51NV2DeviceSettingTypeSelectTarget_RW = 0x51,
    ASP51NV2DeviceSettingTypeSelectAction_RW = 0x52,
    ASP51NV2DeviceSettingTypeSelectMemBank_RW = 0x53,
    ASP51NV2DeviceSettingTypeSelectPointer_RW = 0x54,
    ASP51NV2DeviceSettingTypeSelectMaskLength_RW = 0x55,
    ASP51NV2DeviceSettingTypeSelectMaskValue_RW = 0x56,
    ASP51NV2DeviceSettingTypeTagOperation_RW = 0x60,
    ASP51NV2DeviceSettingTypeAccessPassword_RW = 0x61,
    ASP51NV2DeviceSettingTypeKillPassword_RW = 0x62,
    ASP51NV2DeviceSettingTypeReadMemBank_RW = 0x63,
    ASP51NV2DeviceSettingTypeReadWordPointer_RW = 0x64,
    ASP51NV2DeviceSettingTypeReadWordCount_RW = 0x65,
    ASP51NV2DeviceSettingTypeWriteMemBank_RW = 0x66,
    ASP51NV2DeviceSettingTypeWriteWordPointer_RW = 0x67,
    ASP51NV2DeviceSettingTypeWriteWordCount_RW = 0x68,
    ASP51NV2DeviceSettingTypeWriteData_RW = 0x69,
    ASP51NV2DeviceSettingTypeLockPayload_RW = 0x6A,
    ASP51NV2DeviceSettingTypeBlockPermaLockAction_RW = 0x6B,
    ASP51NV2DeviceSettingTypeBlockPermaLockMemBank_RW = 0x6C,
    ASP51NV2DeviceSettingTypeBlockPermaLockBlockPointer_RW = 0x6D,
    ASP51NV2DeviceSettingTypeBlockPermaLockBlockRange_RW = 0x6E,
    ASP51NV2DeviceSettingTypeBlockPermaLockMask_RW = 0x6F,
    ASP51NV2DeviceSettingTypeWriteEPCLengthControl_RW = 0x70,
    ASP51NV2DeviceSettingTypeWriteEPCLengthValue_RW = 0x71,
    ASP51NV2DeviceSettingTypeWriteEPC_AFI_Control_RW = 0x72,
    ASP51NV2DeviceSettingTypeWriteEPC_AFI_Value_RW = 0x73,
    ASP51NV2DeviceSettingTypeQT_Action_RW = 0x74,
    ASP51NV2DeviceSettingTypeQT_Persistence_RW = 0x75,
    ASP51NV2DeviceSettingTypeQT_DataProfile_RW = 0x76,
    ASP51NV2DeviceSettingTypeQT_AccessRange_RW = 0x77,
    ASP51NV2DeviceSettingTypeQT_TagOperation_RW = 0x78,
    ASP51NV2DeviceSettingTypeAutoStopDurationMS_RW = 0x89,
    ASP51NV2DeviceSettingTypeAutoStopTagCount_RW = 0x8B,
    ASP51NV2DeviceSettingTypeAutoStopRoundCount_RW = 0x8C,
    ASP51NV2DeviceSettingTypeReportControlTag_RW = 0xA1,
    ASP51NV2DeviceSettingTypeReportControlStatus_RW = 0xA2,
    ASP51NV2DeviceSettingTypeReportControlTimestamp_RW = 0xA3,
    ASP51NV2DeviceSettingTypeResponseControlTimestamp_RW = 0xA4,
    ASP51NV2DeviceSettingTypeTemperatureInternal_R = 0xB0,
    ASP51NV2DeviceSettingTypeTemperatureExternal_R = 0xB1,
    ASP51NV2DeviceSettingTypeTemperaturePA_R = 0xB2,
    ASP51NV2DeviceSettingTypeGPIOMode_RW = 0xC0,
    ASP51NV2DeviceSettingTypeGPIOState_RW = 0xC1,
    ASP51NV2DeviceSettingTypeGPIOHighAcion_RW = 0xC2,
    ASP51NV2DeviceSettingTypeGPIOLowAction_RW = 0xC3,
    ASP51NV2DeviceSettingTypeGPIOPulseDuration = 0xC4,
    ASP51NV2DeviceSettingTypeGPIODebounceMS_RW = 0xC5,
    ASP51NV2DeviceSettingTypeGPIOCurrentState_R = 0xC6,
    ASP51NV2DeviceSettingTypeRFMode_RW = 0xD0,
    ASP51NV2DeviceSettingTypeFirstError_R = 0xE0,
    ASP51NV2DeviceSettingTypeLastError_R = 0xE1,
    ASP51NV2DeviceSettingTypeSystemError_R = 0xE2,
    ASP51NV2DeviceSettingTypeCalData_1 = 0xF0,
    ASP51NV2DeviceSettingTypeCalData_2 = 0xF1,
    ASP51NV2DeviceSettingTypeCalData_3 = 0xF2,
    ASP51NV2DeviceSettingTypeCalData_4 = 0xF3,
    ASP51NV2DeviceSettingTypeCalData_5 = 0xF4,
    ASP51NV2DeviceSettingTypeCalData_6 = 0xF5,
    ASP51NV2DeviceSettingTypeCalData_7 = 0xF6,
    ASP51NV2DeviceSettingTypeCalData_8 = 0xF7,
    ASP51NV2DeviceSettingTypeDeviceBaudrate_RW = 0x100,
    ASP51NV2DeviceSettingTypeDeviceIdlePowerMode_RW = 0x101,
    ASP51NV2DeviceSettingTypeOnbootStartAction_RW = 0x102,
    ASP51NV2DeviceSettingTypeEnableLTReports_RW = 0x103,
    ASP51NV2DeviceSettingTypeInBootstrap_R = 0x104,
    ASP51NV2DeviceSettingTypeExternalAntennaMUX_Enable_RW = 0x200,
    ASP51NV2DeviceSettingTypeExternalAntennaMUX_NumAntennas_RW = 0x201,
    ASP51NV2DeviceSettingTypeExternalAntennaMUX_PhysicalPort_RW = 0x202,
    ASP51NV2DeviceSettingTypeExternalAntennaMUX_DelayMicroseconds_RW = 0x203,
    ASP51NV2DeviceSettingTypeANTennaSequenceOption_RW = 0x220,
    ASP51NV2DeviceSettingTypeAntennaDescriptors_RW = 0x221,
    ASP51NV2DeviceSettingTypeAntennaPhysicalPort_RW = 0x222,
    ASP51NV2DeviceSettingTypeTestID_RW = 0x400,
    ASP51NV2DeviceSettingTypeTestParameters_RW = 0x401,
    ASP51NV2DeviceSettingTypeTestResult_1_R = 0x402,
    ASP51NV2DeviceSettingTypeTestResult_2_R = 0x403,
    ASP51NV2DeviceSettingTypeTestResult_3_R = 0x404,
    ASP51NV2DeviceSettingTypeTestData_R = 0x405,
    ASP51NV2DeviceSettingTypeTestFrequency_R = 0x406,
    ASP51NV2DeviceSettingTypeTestPower_R = 0x407,
    ASP51NV2DeviceSettingTypeTestRFMode_R = 0x408,
    ASP51NV2DeviceSettingTypeTestTime_R = 0x409,
    ASP51NV2DeviceSettingTypeTestEvent_R = 0x40A,
    ASP51NV2DeviceSettingTypeTestReports_R = 0x40B,
    ASP51NV2DeviceSettingTypeTestSystem_R = 0x40C,
    ASP51NV2DeviceSettingTypeTestDebugPort_RW = 0x40D,
    ASP51NV2DeviceSettingTypeGenericData_RW = 0xC00,
    ASP51NV2DeviceSettingTypeOEM_Data_R = 0xC01,
    ASP51NV2DeviceSettingTypeBlockWriteOverride_RW = 0x1018,
    ASP51NV2DeviceSettingTypeSJC_Control_RW = 0x101B,
    ASP51NV2DeviceSettingTypeStoredSettingsLoadStatus_R = 0x1021,
    ASP51NV2DeviceSettingTypePA_DIE_TemperatureTX_DutyCycleLimit_RW = 0x1022,
    ASP51NV2DeviceSettingTypeTempCompOffsets_RW = 0x1023,
};

/*
 A type of error code reported by the module or the IRI host libraries
 
 */
typedef NS_ENUM(uint32_t, ASP51NV2ExecutionStatus) {
    ASP51NV2ExecutionStatusSuccess = 0x0,
    ASP51NV2ExecutionStatusGeneralError = 0x1,
    ASP51NV2ExecutionStatusSetKeyInvalid = 0x2,
    ASP51NV2ExecutionStatusSetKeyReadOnly = 0x3,
    ASP51NV2ExecutionStatusSetKeyOutOfRange = 0x4,
    ASP51NV2ExecutionStatusGetKeyInvalid = 0x5,
    ASP51NV2ExecutionStatusGetKeyWriteOnly = 0x6,
    ASP51NV2ExecutionStatusCommandInvalid = 0x7,
    ASP51NV2ExecutionStatusCommandStartFailure = 0x8,
    ASP51NV2ExecutionStatusCommandDecodeFailure = 0x9,
    ASP51NV2ExecutionStatusCommandEncodeFailure = 0xA,
    ASP51NV2ExecutionStatusCommandStalled = 0xB,
    ASP51NV2ExecutionStatusValueInvalid = 0xC,
    ASP51NV2ExecutionStatusMoreThanOneCommandReceived = 0xD,
    ASP51NV2ExecutionStatusNotImplemented = 0xE,
    ASP51NV2ExecutionStatusInvalidProductConfiguration = 0xF,
    ASP51NV2ExecutionStatusInvalidFactorySettings = 0x10,
    ASP51NV2ExecutionStatusResponseEncodeFailure = 0x11,
    ASP51NV2ExecutionStatusCommandVerifyFailure = 0x12,
    ASP51NV2ExecutionStatusInternalNonrecoverable = 0x13,
    ASP51NV2ExecutionStatusTemplateDecodeFailure = 0x14,
    ASP51NV2ExecutionStatusSystemInErrorState = 0x15,
    ASP51NV2ExecutionStatusTestError = 0x16,
    ASP51NV2ExecutionStatusStoredSettingDecode = 0x17,
    ASP51NV2ExecutionStatusValueIndexOutOfRange = 0x18,
    ASP51NV2ExecutionStatusBankIndexOutOfRange = 0x19,
    ASP51NV2ExecutionStatusInvalidProductCalibration = 0x1A,
    ASP51NV2ExecutionStatusReportSizeWouldOverflow = 0x1B,
    ASP51NV2ExecutionStatusFixedHardwareSettingsLoadError = 0x1C,
    ASP51NV2ExecutionStatusGen2TagOtherError = 0x1000001,
    ASP51NV2ExecutionStatusGen2TagMemoryOverrun = 0x1000002,
    ASP51NV2ExecutionStatusGen2TagMemoryLocked = 0x1000003,
    ASP51NV2ExecutionStatusGen2TagInsufficientPower = 0x1000004,
    ASP51NV2ExecutionStatusGen2TagNonSpecificError = 0x1000005,
    ASP51NV2ExecutionStatusAPIDeviceNotInItialized = 0x2000001,
    ASP51NV2ExecutionStatusAPISerialPortError = 0x2000002,
    ASP51NV2ExecutionStatusAPIConnectionReadTimeout = 0x2000003,
    ASP51NV2ExecutionStatusAPIConnectionWriteTimeout = 0x2000004,
    ASP51NV2ExecutionStatusAPIConnectionWriteError = 0x2000005,
    ASP51NV2ExecutionStatusAPIRXBuffTooSmall = 0x2000006,
    ASP51NV2ExecutionStatusAPIMessageInvalid = 0x2000007,
    ASP51NV2ExecutionStatusAPINoHandler = 0x2000008,
    ASP51NV2ExecutionStatusAPIInvalidLoaderBlock = 0x2000009,
    ASP51NV2ExecutionStatusAPIResponseMismatch = 0x200000A,
    ASP51NV2ExecutionStatusAPIInvalidParameter = 0x200000B,
    ASP51NV2ExecutionStatusAPINonLTPacketDetected = 0x200000C,
    ASP51NV2ExecutionStatusIRIFrameDropped = 0x3000001,
    ASP51NV2ExecutionStatusIRIFrameInvalid = 0x3000002,
    ASP51NV2ExecutionStatusMACGeneral = 0x4000001,
    ASP51NV2ExecutionStatusMACCRCMismatch = 0x4000002,
    ASP51NV2ExecutionStatusMACNoTagResponse = 0x4000003,
    ASP51NV2ExecutionStatusMACTagLost = 0x4000004,
    ASP51NV2ExecutionStatusBTSDeviceWatchdogReset = 0x5000001,
    ASP51NV2ExecutionStatusBTSValueInvalid = 0x5000002,
    ASP51NV2ExecutionStatusBTSFlashWrite = 0x5000003,
    ASP51NV2ExecutionStatusBTSFlashRead = 0x5000004,
    ASP51NV2ExecutionStatusBTSFlashAddress = 0x5000005,
    ASP51NV2ExecutionStatusBTSFlashErase = 0x5000006,
    ASP51NV2ExecutionStatusBTSUnknownCommand = 0x5000007,
    ASP51NV2ExecutionStatusBTSCommandDecodeFailure = 0x5000008,
    ASP51NV2ExecutionStatusTransceiverFailure = 0x6000001,
    ASP51NV2ExecutionStatusLimitPATemperatureMax = 0x7000001,
    ASP51NV2ExecutionStatusOtherCommandExecuted = 0x9000001,
    ASP51NV2ExecutionStatusServerNotConnected = 0x9000002,
};

typedef NS_ENUM(NSUInteger, ASP51NV2LogType) {
    ASP51NV2LogTypeNone = 0,
    ASP51NV2LogTypeCrit,
    ASP51NV2LogTypeInfo,
    ASP51NV2LogTypeDebug,
};

@interface ASP51NV2 : NSObject
@property(nonatomic, assign)id _Nullable delegate;

/**
 *  @brief      ASP51NV2 Singleton
 *  @return     ASP51NV2 object
 */
+ (ASP51NV2 * _Nonnull)sharedInstance;

/**
 *  @brief      Get SDK version.
 *  @return     SDK version.
 */
- (NSString * _Nonnull)getSDKVersion;

/**
 *  @brief      Write SDK log.
 *  @param      logType : ASP51NV2LogType
 *                        ASP51NV2LogTypeNone: SDK log will not be writed.
                          ASP51NV2LogTypeCrit: Catch log will be writed.
                          ASP51NV2LogTypeInfo: Catch log and info log will be writed.
                          ASP51NV2LogTypeDebug:Catch log, info log and debug log will be writed.
 */
- (void)setSDKLogType:(ASP51NV2LogType)logType;

/**
 *  @brief      Remove all the SDK logs.
 */
- (void)removeAllSDKLog;

/**
 *  @brief      Search device.
 *  @return     Perform successed return null.
 *              Perform failure return NSError.
 */
- (NSError * _Nullable)startSearchDevice;

/**
 *  @brief      Stop search device.
 *  @return     Perform successed return null.
 *              Perform failure return NSError.
 */
- (NSError * _Nullable)stopSearchDevice;

/**
 *  @brief      Connect device.
 *  @param      IP   : The IP address of the device.
 *  @param      port : The port of the device.
 *  @return     Perform successed return null.
 *              Perform failure return NSError.
 */
- (NSError * _Nullable)connectServerWithIP:(NSString * _Nonnull)IP remoteport:(int)port;

/**
 *  @brief      Disconnect device.
 *  @return     Perform successed return null.
 *              Perform failure return NSError.
 */
- (NSError * _Nullable)disconnectServer;

/**
 *  @brief      Set DHCP.
 *  @param      MACAddress : MAC address
 *  @return     Set successed return YES.
 *              Set failure return NO.
 */
- (BOOL)setDHCPForMACAddress:(NSString * _Nonnull)MACAddress;

/**
 *  @brief      Set DHCP.
 *  @param      MACAddress : MAC address.
 *  @param      IP         : IP address.
 *  @param      subnet     : Subnet mask.
 *  @param      gateway    : Gateway.
 *  @param      DNSServer  : DNS.
 *  @return     Set successed return YES.
 *              Set failure return NO.
 */
- (BOOL)setDHCPForMACAddress:(NSString * _Nonnull)MACAddress
                          IP:(NSString * _Nonnull)IP
                      subnet:(NSString * _Nonnull)subnet
                     gateway:(NSString * _Nonnull)gateway
                   DNSServer:(NSString * _Nonnull)DNSServer;

/**
 *  @brief      Get firmware version.
 */
- (void)getFirmwareVersion;

/**
 *  @brief      Start inventory.
 *  @details    Read RFID tags.
 *  @param      EPC      : Whether EPC data is receive.
 *                         YES:Receive
 *                         NO :Don't receive.
 *
 *  @param      TID      : Whether TID data is receive.
 *                         YES:Receive
 *                         NO :Don't receive.
 *
 *  @param      PC      : Whether PC data is receive.
 *                        YES:Receive
 *                        NO :Don't receive.
 *
 *  @param      RSSI    : Whether RSSI data is receive.
 *                        YES:Receive
 *                        NO :Don't receive.
 *
 *  @param      phase   : Whether phase information is receive.
 *                        YES:Receive
 *                        NO :Don't receive.
 *
 *  @param      channel : Whether channel information is receive.
 *                        YES:Receive
 *                        NO :Don't receive.
 *
 *  @param      antenna : Whether antenna information is received.
 *                        YES:Receive
 *                        NO :Don't receive.
 */
- (void)startInventoryWithEPC:(BOOL)EPC
                          TID:(BOOL)TID
                           PC:(BOOL)PC
                         RSSI:(BOOL)RSSI
                        phase:(BOOL)phase
                      channel:(BOOL)channel
                      antenna:(BOOL)antenna;

/**
 *  @brief      Stop inventory.
 */
- (void)stopInventory;

/**
 *  @brief      Send the "Set region" command to the device
 *  @details    A regulatory region for reader configuration.
 *  @param      region : The enumeration 'RegionType'
 */
- (void)setRegion:(ASP51NV2RegionType)region;
- (void)getRegion;

/**
 *  @brief      Send the "Set output power level" command to the device
 *  @details    Antenna transmit power in dBm (eg. 2300 cdBm = 23 dBm).
 *  @param      powerLevel : The powerLevel range is 0-30.
 */
- (void)setOutputPowerLevel:(uint32_t)powerLevel;
- (void)getOutputPowerLevel;

/**
 *  @brief      Send the "Set session" command to the device
 *  @details    Determines which session the reader will use for tag population management.
 *  @param      session :The enumeration 'SessionType'
 */
- (void)setSession:(ASP51NV2SessionType)session;
- (void)getSession;

/**
 *  @brief      Send the "Device setting" command to the device
 *  @details    A method of setting up all the functions of a device
 *  @param      settingType :The enumeration 'DeviceSettingType'.
 *                           The parameter with W at the end of the enumeration can be set.
 *
 *  @param      value       :The value that can be set for the settingType.
 */
- (void)setDeviceSettingValue:(uint16_t)value
               forSettingType:(ASP51NV2DeviceSettingType)settingType;

/**
 *  @brief      Send the "Get device setting value" command to the device
 *  @param      settingType :The enumeration 'DeviceSettingType'.
 *                           The parameter with R at the end of the enumeration can be get.
 */
- (void)getDeviceSettingValueforSettingType:(ASP51NV2DeviceSettingType)settingType;

/**
 *  @brief      Send the "Set RFMode" command to the device.
 *  @details    RF Mode for inventory operation.
 *              Configures the forward link and reverse link RF parameters for UHF RFID communication with tags.
 *  @param      mode :The enumeration 'RFModeType'.
 */
- (void)setRFMode:(ASP51NV2RFModeType)mode;
- (void)getRFMode;

/**
 *  @brief      Send the "Set searchMode" command to the device.
 *  @details    Inventory Search Mode.
 *              Determines how the reader will manipulate a particular session inventoried flag to control the inventoried tag population.
 *  @param      mode :The enumeration 'SearchModeType'.
 */
- (void)setSearchMode:(ASP51NV2SearchModeType)mode;
- (void)getSearchMode;

/**
 *  @brief      Set antenna ports status.
 *  @details    The sequence of antennas through which the reader will cycle.
 *  @param      antenna1IsOpen : YES:Open.
 *                               NO :Close.
 *
 *  @param      antenna2IsOpen : YES:Open.
 *                               NO :Close.
 *
 *  @param      antenna3IsOpen : YES:Open.
 *                               NO :Close.
 *
 *  @param      antenna4IsOpen : YES:Open.
 *                               NO :Close.
 */
- (void)setAntennaPortsStatusWithAntenna1:(BOOL)antenna1IsOpen
                                 antenna2:(BOOL)antenna2IsOpen
                                 antenna3:(BOOL)antenna3IsOpen
                                 antenna4:(BOOL)antenna4IsOpen;

/**
 *  @brief      Get antenna ports status.
 */
- (void)getAntennaPortsStatus;

/**
 *  @brief      Send the "Read tag" command to the device.
 *  @details    Read tag data from specified memory bank.
 *  @param      accessPassword : If target memory bank was password protected.
 *                               Otherwise, set Access Password to 0x00000000.
 *
 *  @param      EPC            : Target tag’s EPC.
 *
 *  @param      memoryBank     : The enumeration 'MemoryBankType'.
 *
 *  @param      startAddress   : Starting address.
 *
 *  @param      dataLength     : Data Length.
 */
- (void)readTagWithAccessPassword:(uint32_t)accessPassword
                              EPC:(NSData * _Nonnull)EPC
                       memoryBank:(ASP51NV2MemoryBankType)memoryBank
                     startAddress:(uint16_t)startAddress
                       dataLength:(uint16_t)dataLength;

/**
 *  @brief      Send the "Write Tag" command to the device.
 *  @details    Write tag data.
 *  @param      accessPassword : If target memory bank was password protected.
 *                               Otherwise, set Access Password to 0x00000000.
 *
 *  @param      EPC            : Target tag’s EPC.
 *
 *  @param      memoryBank     : The enumeration 'MemoryBankType'.
 *
 *  @param      startAddress   : Starting address.
 *
 *  @param      writeData      : Data to write.
 */
- (void)writeTagWithAccessPassword:(uint32_t)accessPassword
                               EPC:(NSData * _Nonnull)EPC
                        memoryBank:(ASP51NV2MemoryBankType)memoryBank
                      startAddress:(uint16_t)startAddress
                         writeData:(NSData * _Nonnull)writeData;

/**
 *  @brief      Send the "Lock tag" command to the device.
 *  @details    Lock an indicated memory bank in the tag.
 *  @param      accessPassword : If memory bank was password protected.
 *                               Otherwise, set Access Password to 0x00000000.
 *
 *  @param      EPC            : Target tag’s EPC.
 *
 *  @param      targetMemory   : The enumeration 'TargetMemoryType'.
 *
 *  @param      lockAction     : The enumeration 'LockActionType'.
 */
- (void)lockTagWithAccessPassword:(uint32_t)accessPassword
                              EPC:(NSData * _Nonnull)EPC
                     targetMemory:(ASP51NV2TargetMemoryType)targetMemory
                       lockAction:(ASP51NV2LockActionType)lockAction;

/**
 *  @brief      Send the "Kill tag" command to the device.
 *  @details    Kill a Tag.
 *  @param      killPassword : If Kill Password is set to 0x00000000.This command does not work.The target tag ignores it.
 *
 *  @param      EPC          : Target tag’s EPC.
 */
- (void)killTagWithKillPassword:(uint32_t)killPassword
                            EPC:(NSData * _Nonnull)EPC;

/**
 *  @brief      Send the "Select mask" command to the device.
 *  @details    The tag filter.
 *  @param      memoryBank       : The enumeration 'MemoryBankType'.
 *
 *  @param      selectTarget     : The enumeration 'SelectTargetType'.
 *
 *  @param      selectAction     : The enumeration 'SelectActionType'.
 *
 *  @param      startAddressWord : Starting address.
 *
 *  @param      maskData         : Mask value.
 */
- (void)selectMaskWithMemoryBank:(ASP51NV2MemoryBankType)memoryBank
                    selectTarget:(ASP51NV2SelectTargetType)selectTarget
                    selectAction:(ASP51NV2SelectActionType)selectAction
                startAddressWord:(uint16_t)startAddressWord
                        maskData:(NSData * _Nonnull)maskData;
/**
 *  @brief      Clear mask data.
 */
- (void)clearMask;
@end

#pragma mark - ASP51NV2Delegate
@protocol ASP51NV2Delegate <NSObject>
@optional
// Network
/**
 *  @brief      The IP address of the device was received.
 *  @details    This delegate will be called back once the 'startSearchDevice' function is called.
 *  @param      ASP51NV2 : ASP51NV2 object.
 *
 *  @param      IP       : Device's IP address.
 *
 *  @param      isFinish : Search status.
 *                         YES:Search completed.
 *                         NO :Continue to search.
 */
- (void)ASP51NV2:(ASP51NV2 *_Nonnull)ASP51NV2
     searchingIP:(NSString *_Nonnull)IP
        isFinish:(BOOL)isFinish;

/**
 *  @brief      The DHCP information of the device was received.
 *  @details    This delegate will be called back once the 'startSearchDevice' function is called.
 *  @param      ASP51NV2 : ASP51NV2 object.
 *
 *  @param      arrInfos : Device information array.
 *                         For example:
                           [
                              {
                                dhcp = STATIC;
                                dns = "192.168.1.1";
                                gateway = "192.168.1.1";
                                ip = "192.168.1.129";
                                mac = "00:08:DC:56:87:33";
                                subnet = "255.255.255.0";
                              },
                              {
                                dhcp = STATIC;
                                dns = "192.168.1.255";
                                gateway = "192.168.1.1";
                                ip = "192.168.1.130";
                                mac = "00:08:DC:56:87:39";
                                subnet = "255.255.255.0";
                              }
                           ]
 */
- (void)ASP51NV2:(ASP51NV2 *_Nonnull)ASP51NV2 searchedUPDSearchingDeviceInfo:(NSArray *_Nonnull)arrInfos;

/**
 *  @brief      The Network state was received.
 *  @details    This delegate will be called back when the network state changes.
 *  @param      ASP51NV2 : ASP51NV2 object.
 *  @param      state : The enumeration 'ASP51NV2NetworkState'.
 *  @param      error : Error message that occurs when the network state changes.
 */
- (void)ASP51NV2:(ASP51NV2 *_Nonnull)ASP51NV2
changeNetworkState:(ASP51NV2NetworkState)state
           error:(NSError *_Nullable)error;

// ReceivedData
/**
 *  @brief      The scanned tags information was received.
 *  @details    This delegate will be called back once the 'startInventoryWithEPC' function is called.
 *  @param      ASP51NV2 : ASP51NV2 object.
 *
 *  @param      RSSI     : RSSI data.
 *
 *  @param      channel  : Channel information.
 *
 *  @param      phase    : Phase information.
 *
 *  @param      antenna  : Antenna information.
 *
 *  @param      PC       : PC data.
 *
 *  @param      EPC      : EPC data.
 *
 *  @param      TID      : TID data.
 */
- (void)ASP51NV2:(ASP51NV2 *_Nonnull)ASP51NV2
receivedInventoryDataWithRSSI:(NSString * _Nonnull)RSSI
         channel:(NSString * _Nonnull)channel
           phase:(NSString * _Nonnull)phase
         antenna:(NSString * _Nonnull)antenna
              PC:(NSString * _Nonnull)PC
             EPC:(NSString * _Nonnull)EPC
             TID:(NSString * _Nonnull)TID;

/**
 *  @brief      The readed tags information was received.
 *  @details    This delegate will be called back once the 'readTagWithAccessPassword' function is called.
 *  @param      ASP51NV2             : ASP51NV2 object.
 *
 *  @param      tagOperationData     : readed data.
 */
- (void)ASP51NV2:(ASP51NV2 *_Nonnull)ASP51NV2 receivedTagOperationData:(NSData *_Nullable)tagOperationData;

//Inventory
/**
 *  @brief      This delegate will be called back once the 'stopInventory' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2 didStopInventoryExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

/**
 *  @brief      This delegate will be called back once the 'startInventoryWithEPC' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2 didStartInventoryExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

// OutputPower
/**
 *  @brief      This delegate will be called back once the 'setOutputPowerLevel' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2 didSetOutputPowerLevelExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

/**
 *  @brief      This delegate will be called back once the 'getOutputPowerLevel' function is called.
 *  @param      ASP51NV2         : ASP51NV2 object.
 *
 *  @param      outputPowerLevel : Output power level.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured,  and the value of parameter 'outputPowerLevel' will be invalid.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2
receivedOutputPowerLevel:(uint8_t)outputPowerLevel
 executionStatus:(ASP51NV2ExecutionStatus)statusCode;

// Region
/**
 *  @brief      This delegate will be called back once the 'setRegion' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2 didSetRegionExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

/**
 *  @brief      This delegate will be called back once the 'getRegion' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      region     : The enumeration 'RegionType'.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured,  and the value of parameter 'region' will be invalid.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2
  receivedRegion:(ASP51NV2RegionType)region
 executionStatus:(ASP51NV2ExecutionStatus)statusCode;

// RFMode
/**
 *  @brief      This delegate will be called back once the 'setRFMode' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2 didSetRFModeExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

/**
 *  @brief      This delegate will be called back once the 'getRFMode' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      RFMode     : The enumeration 'RFModeType'.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured, and the value of parameter RFMode will be invalid.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2
 receivedRFMode:(ASP51NV2RFModeType)RFMode
 executionStatus:(ASP51NV2ExecutionStatus)statusCode;

// SetSearchMode add
/**
 *  @brief      This delegate will be called back once the 'setSearchMode' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2 didSetSearchModeExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

/**
 *  @brief      This delegate will be called back once the 'getSearchMode' function is called.
 *  @param      ASP51NV2    : ASP51NV2 object.
 *
 *  @param      searchModel : The enumeration 'SearchModeType'.
 *
 *  @param      statusCode  : The enumeration 'ExecutionStatus'.
 *                            If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured, and the value of parameter 'searchModel' will be invalid.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2
receivedSetSearchMode:(ASP51NV2SearchModeType)searchModel
 executionStatus:(ASP51NV2ExecutionStatus)statusCode;

// SetValue
/**
 *  @brief      This delegate will be called back once the 'setDeviceSettingValue' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2 didSetDeviceSettingValueExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

/**
 *  @brief      This delegate will be called back once the 'getDeviceSettingValueforSettingType' function is called.
 *  @param      ASP51NV2     : ASP51NV2 object.
 *
 *  @param      settingValue : Device setting value.
 *
 *  @param      statusCode   : The enumeration 'ExecutionStatus'.
 *                             If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured, and the value of parameter 'settingValue' will be invalid.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2 receivedDeviceSettingValue:(uint8_t)settingValue executionStatus:(ASP51NV2ExecutionStatus)statusCode;

// AntennaPorts
/**
 *  @brief      This delegate will be called back once the 'setAntennaPortsStatusWithAntenna1' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2 didSetAntennaPortsStatusExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

/**
 *  @brief      This delegate will be called back once the 'getAntennaPortsStatus' function is called.
 *  @param      ASP51NV2       : ASP51NV2 object.
 *
 *  @param      antenna1IsOpen : YES:Antenna1 opened.
 *                               NO :Antenna1 closed.
 *
 *  @param      antenna2IsOpen : YES:Antenna2 opened.
 *                               NO :Antenna2 closed.
 *
 *  @param      antenna3IsOpen : YES:Antenna3 opened.
 *                               NO :Antenna3 closed.
 *
 *  @param      antenna4IsOpen : YES:Antenna4 opened.
 *                               NO :Antenna4 closed.
 *
 *  @param      statusCode     : The enumeration 'ExecutionStatus'.
 *                               If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured, and the values of parameters 'antenna1IsOpen' and 'antenna2IsOpen' and 'antenna3IsOpen' and 'antenna4IsOpen' will be invalid.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2 receivedAntennaPortsStatus:(BOOL)antenna1IsOpen
        antenna2:(BOOL)antenna2IsOpen
        antenna3:(BOOL)antenna3IsOpen
        antenna4:(BOOL)antenna4IsOpen
 executionStatus:(ASP51NV2ExecutionStatus)statusCode;

// Kill
/**
 *  @brief      This delegate will be called back once the 'killTagWithKillPassword' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2 didKillTagExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

// Write
/**
 *  @brief      This delegate will be called back once the 'writeTagWithAccessPassword' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : ExecutionStatus. If statusCode is not ExecutionStatusSuccess, return error status code.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2 didWriteTagExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

// Lock
/**
 *  @brief      This delegate will be called back once the 'lockTagWithAccessPassword' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 * _Nonnull)ASP51NV2 didLockTagExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

// Read
/**
 *  @brief      This delegate will be called back once the 'readTagWithAccessPassword' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 *_Nonnull)ASP51NV2 didReadTagExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

// SelectMask
/**
 *  @brief      This delegate will be called back once the 'selectMaskWithMemoryBank' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 *_Nonnull)ASP51NV2 didSelectMaskExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

/**
 *  @brief      This delegate will be called back once the 'clearMask' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 *_Nonnull)ASP51NV2 didClearMaskExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

// Session
/**
 *  @brief      This delegate will be called back once the 'setSession' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured.
 */
- (void)ASP51NV2:(ASP51NV2 *_Nonnull)ASP51NV2 didSetSessionExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

/**
 *  @brief      This delegate will be called back once the 'getSession' function is called.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *
 *  @param      session    : The enumeration 'SessionType'.
 *
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 *                           If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured, and the value of parameter 'session' will be invalid.
 */
- (void)ASP51NV2:(ASP51NV2 *_Nonnull)ASP51NV2 receivedSession:(ASP51NV2SessionType)session executionStatus:(ASP51NV2ExecutionStatus)statusCode;

/**
 *  @brief      This delegate will be called back once the 'getFirmwareVersion' function is called.
 *  @param      ASP51NV2        : ASP51NV2 object.
 *
 *  @param      firmwareVersion : Firmware version.
 *
 *  @param      statusCode      : The enumeration 'ExecutionStatus'.
 *                                If the value of statusCode is not 'ExecutionStatusSuccess', an error will occured, and the value of parameter 'firmwareVersion' will be invalid.
 */
- (void)ASP51NV2:(ASP51NV2 *_Nonnull)ASP51NV2
receivedFirmwareVersion:(NSString *_Nonnull)firmwareVersion
 executionStatus:(ASP51NV2ExecutionStatus)statusCode;

//ExecutionStatus
/**
 *  @brief      This delegate will be called back When module, RFID, or host library operations fail, and can be used to indicate what has gone wrong.
 *  @param      ASP51NV2   : ASP51NV2 object.
 *  @param      statusCode : The enumeration 'ExecutionStatus'.
 */
- (void)ASP51NV2:(ASP51NV2 *_Nonnull)ASP51NV2 receivedExecutionStatus:(ASP51NV2ExecutionStatus)statusCode;

//DefaultSetting
/**
 *  @brief      Response to "Default Setting".
 *  @param      ASP51NV2    : ASP51NV2 object.
 *  @param      isSuccessed : If isSuccessed is not YES, return error data dictionary.
 *  @param      errorData   : Error data dictionary.
 */
- (void)ASP51NV2:(ASP51NV2 *_Nonnull)ASP51NV2 defaultSettingSuccessed:(BOOL)isSuccessed errorData:(NSMutableDictionary * _Nullable)errorData;
@end
