#import "SessionController.h"
#import "Utils.h"
#import <ASP51NV2SDK/ASP51NV2SDK.h>
@interface SessionController ()<ASP51NV2Delegate>
{
    int selectedSession;
}

@end

@implementation SessionController

#pragma mark - Lifecycle
- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [ASP51NV2 sharedInstance].delegate = self;
    
    [self performSelector:@selector(onTickGetSession)   withObject:nil afterDelay:.4f];
    [Utils showLoadingView:@"" timeOut:df_TIMEOUT_DEFAULT];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    [ASP51NV2 sharedInstance].delegate = nil;
}

#pragma mark - IBAction
- (IBAction)btnSetSession:(id)sender
{
//    zzz
//    NSError *error = [[ASP51NV2SDK sharedInstance] setSession:selectedSession];
//    if( error ){
//        NSLog(@"%@\n code = %d\n%@", NSStringFromSelector(_cmd), (int)error.code, error.userInfo);
//    }
    [Utils showLoadingView:@"" timeOut:df_TIMEOUT_DEFAULT];
    [[ASP51NV2 sharedInstance] setSession:selectedSession];
}

#pragma mark - Private Method
- (void)onTickGetSession
{
//    zzz
//    NSError *error = [[ASP51NV2SDK sharedInstance] getSession];
//    if( error ){
//        NSLog(@"%@\n code = %ld\n%@", NSStringFromSelector(_cmd), error.code, error.userInfo);
//    }
    [[ASP51NV2 sharedInstance] getSession];
}

#pragma mark - ASP51NV2 Delegate
- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 didSetSessionExecutionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    if (statusCode == ASP51NV2ExecutionStatusSuccess) {
        [Utils hiddenLoadingView];
        [Utils showAlert:@"Success" message:@"Session changed" view:self];
    } else {
        if (statusCode == ASP51NV2ExecutionStatusOtherCommandExecuted) {
            
        } else {
            [Utils hiddenLoadingView];
        }
        [Utils showAlert:@"Session changed Fail" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 receivedSession:(ASP51NV2SessionType)session executionStatus:(ASP51NV2ExecutionStatus)statusCode {
    if (statusCode == ASP51NV2ExecutionStatusSuccess) {
        [Utils hiddenLoadingView];
        selectedSession = session;
        dispatch_async(dispatch_get_main_queue(),^{
            [self.tableView reloadData];
        });
    } else {
        if (statusCode == ASP51NV2ExecutionStatusOtherCommandExecuted) {
            
        } else {
            [Utils hiddenLoadingView];
        }
        [Utils showAlert:@"Session Fail" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 changeNetworkState:(ASP51NV2NetworkState)state error:(NSError *)error
{
    switch (state) {
        case ASP51NV2NetworkStateDisconnected:
            [Utils showAlert:@"Fail" message:@"The network connection is lost." view:self];
            break;
        case ASP51NV2NetworkStateError:
            break;
        default:
            break;
    }
}

- (void)ASP51NV2:(ASP51NV2 *)ASP51NV2 receivedExecutionStatus:(ASP51NV2ExecutionStatus)statusCode
{
    [Utils showAlert:@"Error" message:[NSString stringWithFormat:@"%x", statusCode] view:self];
}

#pragma mark - TableView DataSource
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return 4;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    cell.textLabel.text = [NSString stringWithFormat:@"SESSION_S%d", (int)indexPath.row];
    
    if(selectedSession == indexPath.row)
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    else
        cell.accessoryType = UITableViewCellAccessoryNone;
    return cell;
}

#pragma mark - TableView Delegate
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    selectedSession = (int)indexPath.row;
    [self.tableView reloadData];
}
@end
